/*
 * main implementation: use this 'C' sample to create your own application
 *
 */

#include "derivative.h" /* include peripheral declarations */

extern void xcptn_xmpl(void);


/*******************************************************************************
* Constants and macros
*******************************************************************************/

uint32_t destination_data[5]={0};
int32_t count,count1,count2;
/*******************************************************************************
* External objects
*******************************************************************************/

/*******************************************************************************
* Global variables
*******************************************************************************/
volatile struct CAN_tag *CAN[3] = {&CAN_0, &CAN_1, &CAN_2};

__attribute__ ((section(".text")))
void CAN_ConfigurePads()
{
	SIUL2.MSCR[17].R = 0x00080000 | 0;
	SIUL2.IMCR[32].R = 0x2;

	SIUL2.MSCR[16].R = 0x02000000 | 0x01;
}
void CAN_Init(unsigned int nbModule)
{
	unsigned int i;

    CAN_ConfigurePads();

    //CLKSRC is 1 for PLL0-PHI, MDIS still set after reset
    CAN[nbModule]->CTRL1.B.CLKSRC = 1;//ѡʱ  160/4=40M

    //Ensure that FlexCan is in FREEZE
    CAN[nbModule]->MCR.B.MDIS = 0;
    CAN[nbModule]->MCR.B.FRZ = 1;
    CAN[nbModule]->MCR.B.HALT = 1;

    for(i=0; i<2000; i++)
    {
        if (CAN[nbModule]->MCR.B.NOTRDY && CAN[nbModule]->MCR.B.FRZACK && !CAN[nbModule]->MCR.B.LPMACK)
            break;
    }

    //Configuration  Ϊ500K
    CAN[nbModule]->CTRL1.B.PRESDIV = 4;//3       // 40 MHz / (4+1) = 8 MHz
    CAN[nbModule]->CTRL1.B.RJW = 3;//1;
    CAN[nbModule]->CTRL1.B.PSEG1 = 4;//1;
    CAN[nbModule]->CTRL1.B.PSEG2 = 4;//1;
    CAN[nbModule]->CTRL1.B.BOFFMSK = 0;
    CAN[nbModule]->CTRL1.B.ERRMSK = 0;
    CAN[nbModule]->CTRL1.B.CLKSRC = 1;        // read-only in freeze mode (value for read-back)
    CAN[nbModule]->CTRL1.B.LPB = 0;           // loopback mode disabled
    CAN[nbModule]->CTRL1.B.TWRNMSK = 0;
    CAN[nbModule]->CTRL1.B.RWRNMSK = 0;
    CAN[nbModule]->CTRL1.B.SMP = 0;
    CAN[nbModule]->CTRL1.B.BOFFREC = 0;
    CAN[nbModule]->CTRL1.B.TSYN = 0;
    CAN[nbModule]->CTRL1.B.LBUF = 0;		//ȼȷ
    CAN[nbModule]->CTRL1.B.LOM = 0;
    CAN[nbModule]->CTRL1.B.PROPSEG = 4;

    CAN[nbModule]->CTRL2.B.ECRWRE = 0;
    CAN[nbModule]->CTRL2.B.WRMFRZ = 1;        // allow SRAM access in freeze mode
    CAN[nbModule]->CTRL2.B.RFFN = 0;          // 8 Rx FIFO filters
    CAN[nbModule]->CTRL2.B.TASD = 16;
    CAN[nbModule]->CTRL2.B.MRP = 0;
    CAN[nbModule]->CTRL2.B.RRS = 0;
    CAN[nbModule]->CTRL2.B.EACEN = 0;

    CAN[nbModule]->MCR.B.MDIS = 0;
    CAN[nbModule]->MCR.B.FRZ = 1;
    CAN[nbModule]->MCR.B.RFEN = 0;            // RX FIFO not needed
    CAN[nbModule]->MCR.B.HALT = 1;
    CAN[nbModule]->MCR.B.NOTRDY = 1;
    CAN[nbModule]->MCR.B.SOFTRST = 0;
    CAN[nbModule]->MCR.B.FRZACK = 1;
    CAN[nbModule]->MCR.B.SUPV = 1;
    CAN[nbModule]->MCR.B.WRNEN = 0;
    CAN[nbModule]->MCR.B.LPMACK = 0;
    CAN[nbModule]->MCR.B.SRXDIS = 1;   // SRXDIS =1, self reception disabled
    CAN[nbModule]->MCR.B.IRMQ = 0;
    CAN[nbModule]->MCR.B.LPRIOEN = 0;
    CAN[nbModule]->MCR.B.AEN = 0;
    CAN[nbModule]->MCR.B.IDAM = 0;
    CAN[nbModule]->MCR.B.MAXMB = (64 - 1);

    //Enable all IRQs
    CAN[nbModule]->IMASK1.R = 0;//0xFFFFFFFF;
    CAN[nbModule]->IMASK2.R = 0;//0xFFFFFFFF;//رMB63-MB32ж

    //Mem init
    //Stay in the Freeze mode

    //Clear message buffers
    for(i = 0; i < 64; i++){
        CAN[nbModule]->MB[i].CS.R = 0;
        CAN[nbModule]->MB[i].ID.R = 0;
        CAN[nbModule]->MB[i].DATA.W[0] = 0;
        CAN[nbModule]->MB[i].DATA.W[1] = 0;
    }

    //Clear RX filters
    for(i= 0; i < 64; i++){
        CAN[nbModule]->RXIMR[i].R = 0;
    }

    //Clear internal buffers
    for(i=0; i<24; i++){
        CAN[nbModule]->RXIMR[i+128].R = 0;
    }

    //Disable RX FIFO message filter (accept all)
    CAN[nbModule]->RXMGMASK.R = 0;//0x0C07EF9C//~0x0C07EF9C

    //Enable module
    CAN[nbModule]->MCR.B.MDIS = 0;
    CAN[nbModule]->MCR.B.HALT = 0;

    CAN[nbModule]->MCR.R = 0x0000080F;

	for(i=0; i<1000; i++){
        if (!CAN[nbModule]->MCR.B.NOTRDY && !CAN[nbModule]->MCR.B.FRZACK && !CAN[nbModule]->MCR.B.LPMACK)
            break;
    }

}

void CAN_Send(unsigned char nbModule, unsigned char nbBuffer,unsigned int id)
{

	CAN[nbModule]->MB[nbBuffer].CS.R = 0x08680000;   //չ֡Length = 8 Bytes
	CAN[nbModule]->MB[nbBuffer].ID.R = id;

	CAN[nbModule]->MB[nbBuffer].DATA.W[0] = destination_data[3];//((data[3]<<24) | (data[2]<<16) | (data[1]<<8) | data[0]);	//Byte0 - Byte3  of the message
	CAN[nbModule]->MB[nbBuffer].DATA.W[1] = count1;//((data[7]<<24) | (data[6]<<16) | (data[5]<<8) | data[4]);	//Byte4 - Byte7 of the message
	CAN[nbModule]->MB[nbBuffer].CS.B.CODE = 0xc;  	//After transmission, the MB automatically becomes an Rx MB with the same ID.
}
/*******************************************************************************
* Local functions
*******************************************************************************/
void AIPS_0_Init(void)
{
    // All Master Can go through AIPS_0 and all peripheral have no protection

    // Master Privilege Register A
    AIPS_0.MPRA.R      = 0x77777777;
    // Peripheral Access Control Register
    AIPS_0.PACR[0].R    = 0x0;
    AIPS_0.PACR[1].R    = 0x0;
    AIPS_0.PACR[2].R    = 0x0;
    AIPS_0.PACR[3].R    = 0x0;
    //AIPS_0.PACR[4].R    = 0x0; - Reserved, not implemented
    AIPS_0.PACR[5].R    = 0x0;
    AIPS_0.PACR[6].R    = 0x0;
    AIPS_0.PACR[7].R    = 0x0;

    // Off-Platform Peripheral Access Control Register
    AIPS_0.OPACR[0].R	= 0x0;
    AIPS_0.OPACR[1].R	= 0x0;
    AIPS_0.OPACR[2].R	= 0x0;
    AIPS_0.OPACR[3].R	= 0x0;
    AIPS_0.OPACR[4].R	= 0x0;
    AIPS_0.OPACR[5].R	= 0x0;
    AIPS_0.OPACR[6].R	= 0x0;
    AIPS_0.OPACR[7].R	= 0x0;
    AIPS_0.OPACR[8].R	= 0x0;
    AIPS_0.OPACR[9].R	= 0x0;
    AIPS_0.OPACR[10].R	= 0x0;
    AIPS_0.OPACR[11].R	= 0x0;
    AIPS_0.OPACR[12].R	= 0x0;
    AIPS_0.OPACR[13].R	= 0x0;
    AIPS_0.OPACR[14].R	= 0x0;
    AIPS_0.OPACR[15].R	= 0x0;
    AIPS_0.OPACR[16].R	= 0x0;
    AIPS_0.OPACR[17].R	= 0x0;
    AIPS_0.OPACR[18].R	= 0x0;
    AIPS_0.OPACR[19].R	= 0x0;
    AIPS_0.OPACR[20].R	= 0x0;
    AIPS_0.OPACR[21].R	= 0x0;
    AIPS_0.OPACR[22].R	= 0x0;
    AIPS_0.OPACR[23].R	= 0x0;
    AIPS_0.OPACR[24].R	= 0x0;
    AIPS_0.OPACR[25].R	= 0x0;
    AIPS_0.OPACR[26].R	= 0x0;
    AIPS_0.OPACR[27].R	= 0x0;
    AIPS_0.OPACR[28].R	= 0x0;
    AIPS_0.OPACR[29].R	= 0x0;
    AIPS_0.OPACR[30].R	= 0x0;
    AIPS_0.OPACR[31].R	= 0x0;
}
void AIPS_1_Init(void)
{
    // All Master Can go through AIPS_1 and all peripheral have no protection

    // Master Privilege Register A
    AIPS_1.MPRA.R      = 0x77777777;
    // Peripheral Access Control Register
    AIPS_1.PACR[0].R    = 0x0;
    AIPS_1.PACR[1].R    = 0x0;
    AIPS_1.PACR[2].R    = 0x0;
    AIPS_1.PACR[3].R    = 0x0;
    //AIPS_0.PACR[4].R    = 0x0; - Reserved, not implemented
    AIPS_1.PACR[5].R    = 0x0;
    AIPS_1.PACR[6].R    = 0x0;
    AIPS_1.PACR[7].R    = 0x0;

    // Off-Platform Peripheral Access Control Register
    AIPS_1.OPACR[0].R	= 0x0;
    AIPS_1.OPACR[1].R	= 0x0;
    AIPS_1.OPACR[2].R	= 0x0;
    AIPS_1.OPACR[3].R	= 0x0;
    AIPS_1.OPACR[4].R	= 0x0;
    AIPS_1.OPACR[5].R	= 0x0;
    AIPS_1.OPACR[6].R	= 0x0;
    AIPS_1.OPACR[7].R	= 0x0;
    AIPS_1.OPACR[8].R	= 0x0;
    AIPS_1.OPACR[9].R	= 0x0;
    AIPS_1.OPACR[10].R	= 0x0;
    AIPS_1.OPACR[11].R	= 0x0;
    AIPS_1.OPACR[12].R	= 0x0;
    AIPS_1.OPACR[13].R	= 0x0;
}
/*******************************************************************************
Function Name : Sys_Init
Engineer      : b21190
Date          : Oct-22-2014
Parameters    : NONE
Modifies      : NONE
Returns       : NONE
Notes         : Clock settings
Issues        : NONE
*******************************************************************************/
void InitPeriClkGen(void)
{
	      // MC_CGM.SC_DC0.R = 0x80030000;    // PBRIDGE0/PBRIDGE1_CLK at syst clk div by 4 ... (50 MHz)
	      MC_CGM.AC0_SC.R = 0x02000000;    // Select PLL0 for auxiliary clock 0
	      MC_CGM.AC0_DC0.R = 0x80000000;    // MOTC_CLK : Enable aux clk 0 div by 1=160 MHz)
	      MC_CGM.AC0_DC1.R = 0x80090000;    // SGEN_CLK : Enable aux clk 0 div by 10 =16 MHz)
	      MC_CGM.AC0_DC2.R = 0x80010000;    // ADC_CLK : Enable aux clk 0 div by 2 =80 MHz)
	      MC_CGM.AC6_SC.R = 0x04000000;    // Select PLL1 for auxiliary clock 6
	      MC_CGM.AC6_DC0.R = 0x80090000;    // CLKOUT0 : Enable aux clk 6 div by 4 =50 MHz)
//	      MC_CGM.AC10_SC.R = 0x04000000;    // Select PLL1 for auxiliary clock 10
//	      MC_CGM.AC10_DC0.R = 0x80030000;    // ENET_CLK : Enable aux clk 10 div by 4=50 MHz)
//	      MC_CGM.AC11_SC.R = 0x04000000;    // Select PLL1 for auxiliary clock 11
//	      MC_CGM.AC11_DC0.R = 0x80030000;    // ENET_TIME_CLK : Enable aux clk 11 div by 4 =50 MHz)
//	      MC_CGM.AC5_SC.R = 0x02000000;    // Select PLL0 for auxiliary clock 5
//	      MC_CGM.AC5_DC0.R = 0x80000000;    // LFAST_CLK : Enable aux clk 5 div by 1 =50 MHz)
	      MC_CGM.AC2_DC0.R = 0x80030000;    // CAN_PLL_CLK : Enable aux clk 2 (PLL0) div by 4 =40 MHz)
	      MC_CGM.AC1_DC0.R = 0x80010000;    // FRAY_PLL_CLK : Enable aux clk 1 (PLL0) div by 2=80 MHz)
	      MC_CGM.AC1_DC1.R = 0x80090000;    // SENT_CLK : Enable aux clk 1 (PLL0) div by 10=16 MHz)max 80M
}

void SysClk_Init(void)
{

	      MC_CGM.AC3_SC.B.SELCTL = 0x01;		    //connect XOSC to the PLL0 input
	      MC_CGM.AC4_SC.B.SELCTL = 0x01;		    //connect XOSC to the PLL1 input

	      // Set PLL0 to 160 MHz with 40MHz XOSC reference
	     // PLLDIG.PLL0DV.R = 0x3008100A;	     // PREDIV =  1, MFD = 10, RFDPHI = 8, RFDPHI1 = 6
	      PLLDIG.PLL0DV.B.RFDPHI1 = 8;
	      PLLDIG.PLL0DV.B.RFDPHI = 2;
	      PLLDIG.PLL0DV.B.PREDIV = 1;
	      PLLDIG.PLL0DV.B.MFD = 8;

	      MC_ME.RUN0_MC.R = 0x00130070;		    // RUN0 cfg: IRCON,OSC0ON,PLL0ON,syclk=IRC

	      // Mode Transition to enter RUN0 mode:
	      MC_ME.MCTL.R = 0x40005AF0;		    // Enter RUN0 Mode & Key
	      MC_ME.MCTL.R = 0x4000A50F;		    // Enter RUN0 Mode & Inverted Key
	      while (MC_ME.GS.B.S_MTRANS) {};		    // Wait for mode transition to complete
	      while(MC_ME.GS.B.S_CURRENT_MODE != 4) {};	    // Verify RUN0 is the current mode

	      // Set PLL1 to 200 MHz with 40MHz XOSC reference
	      PLLDIG.PLL1DV.R = 0x00020014;	     // MFD = 20, RFDPHI = 2

	      MC_ME.RUN_PC[0].R = 0x000000FE;		    // enable peripherals run in all modes
	      MC_ME.RUN0_MC.R = 0x001300F4;		    // RUN0 cfg: IRCON, OSC0ON, PLL1ON, syclk=PLL1

	      MC_CGM.SC_DC0.R = 0x80030000;    // PBRIDGE0/PBRIDGE1_CLK at syst clk div by 4 ... (50 MHz)

	      // Mode Transition to enter RUN0 mode:
	      MC_ME.MCTL.R = 0x40005AF0;		    // Enter RUN0 Mode & Key
	      MC_ME.MCTL.R = 0x4000A50F;		    // Enter RUN0 Mode & Inverted Key
	      while (MC_ME.GS.B.S_MTRANS) {};		    // Wait for mode transition to complete
	      while(MC_ME.GS.B.S_CURRENT_MODE != 4) {};	    // Verify RUN0 is the current mode

	      InitPeriClkGen();
}

/*******************************************************************************
Function Name : SUIL2_Init
Engineer      : b21190
Date          : Oct-22-2014
Parameters    : NONE
Modifies      : NONE
Returns       : NONE
Notes         : SIUL2 initialization (ports), setting PB6(B9) as output for clock measurement
Issues        : NONE
*******************************************************************************/
void SUIL2_Init(void)
{
	SIUL2.MSCR[46].R = 0x30000000 | 0x02000000 | 0x2; // CTU0 External Trigger Output (on EVB it is PC[14])
	SIUL2.MSCR[2].R = 0x1; //eTimer output pin  OFLAG
//	SIUL2.MSCR[84].R = 0x02080000;//ڲԷת

	SIUL2.MSCR[33].R = 0x00400000; // C[1] pin as ADC0 AN[2] input		pin 41	SBC_MUXOUT
//	SIUL2.MSCR[68].R = 0x00400000; // E[4] pin as ADC0 AN[7] input		pin 42	12Vѹ1
	SIUL2.MSCR[23].R = 0x00400000; // B[7] pin as ADC0 AN[0] input		pin 43	12VԴ
//	SIUL2.MSCR[69].R = 0x00400000; // E[5] pin as ADC0 AN[8] input		pin 44	2.5V ADCУ׼ѹ
	SIUL2.MSCR[34].R = 0x00400000; // C[2] pin as ADC0 AN[3] input		pin 45	ĸߵѹ
//	SIUL2.MSCR[70].R = 0x00400000; // E[6] pin as ADC0 AN[4] input		pin 46	źŲ
	SIUL2.MSCR[24].R = 0x00400000; // B[8] pin as ADC0 AN[1] input		pin 47	¶ȴ1
//	SIUL2.MSCR[71].R = 0x00400000; // E[7] pin as ADC0 AN[6] input		pin 48	U
//	SIUL2.MSCR[66].R = 0x00400000; // E[2] pin as ADC0 AN[5] input		pin 49	ѹ
//
//	SIUL2.MSCR[25].R = 0x00400000; // B[9] pin as ADC0_1 AN[11] input		pin 52	UIGBT¶Ȳ
//	SIUL2.MSCR[26].R = 0x00400000; // B[10] pin as ADC0_1 AN[12] input		pin 53	Եѹ
//	SIUL2.MSCR[27].R = 0x00400000; // B[11] pin as ADC0_1 AN[13] input		pin 54	õԴ
//
//	SIUL2.MSCR[29].R = 0x00400000; // B[13] pin as ADC1 AN[0] input		pin 60	VIGBT¶Ȳ
//	SIUL2.MSCR[73].R = 0x00400000; // E[9] pin as ADC1 AN[7] input		pin 61	W
//	SIUL2.MSCR[31].R = 0x00400000; // B[15] pin as ADC1 AN[2] input		pin 62	12Vѹ2
//	SIUL2.MSCR[74].R = 0x00400000; // E[10] pin as ADC1 AN[8] input		pin 63	WIGBT¶Ȳ
//	SIUL2.MSCR[30].R = 0x00400000; // B[14] pin as ADC1 AN[1] input		pin 64	¶ȴ2
//	SIUL2.MSCR[75].R = 0x00400000; // E[11] pin as ADC1 AN[4] input		pin 65	ưPCB¶Ȳ
//	SIUL2.MSCR[32].R = 0x00400000; // C[0] pin as ADC1 AN[3] input		pin 66	0.5V ADCУ׼ѹ
//	SIUL2.MSCR[76].R = 0x00400000; // E[12] pin as ADC1 AN[6] input		pin 67	DCĸߵ루ã
//	SIUL2.MSCR[64].R = 0x00400000; // E[0] pin as ADC1 AN[5] input		pin 68	V
}

/*******************************************************************************
Function Name : CTU_Init
Engineer      : b21190
Date          : Apr-13-2015
Parameters    : NONE
Modifies      : NONE
Returns       : NONE
Notes         : Initialize CTU_0
Issues        : NONE
*******************************************************************************/


/*******************************************************************************
Function Name : eTimer_Init
Engineer      : b21190
Date          : Mar-19-2015
Parameters    : NONE
Modifies      : NONE
Returns       : NONE
Notes         : eTimer will trigger CTU MSR(master reset signal)
Issues        : NONE
*******************************************************************************/
void eTimer_Init(void)
{
    //Initialize eTimer0_ch0 to generate pwm output signal and CTU MSR signal
    ETIMER_0.CH[2].CNTR.R = 0x0000;		// Initial value
    ETIMER_0.CH[2].CTRL1.B.CNTMODE = 0x1;	// Counter mode = count rising edges

    ETIMER_0.CH[2].CTRL2.B.OEN = 0x1;		// Output enable
    ETIMER_0.CH[2].CTRL1.B.LENGTH = 1;//0x0;	// Continue counting to roll over
    ETIMER_0.CH[2].LOAD.R = 0x1;		// Reload value used to initialize the counter
    ETIMER_0.CH[2].COMP1.R = 5000;	 	// OFLAG 򿪵ֵ
    ETIMER_0.CH[2].COMP2.R = 16000;		// 100us ֵ    OFLAGرյֵ
    ETIMER_0.CH[2].CTRL2.B.OUTMODE = 0x8;//0x3;	// Toggle OFLAG output on successful compare (COMP1 or COMP2)

    //ETIMER_0.CH[2].CMPLD1.R = 0x500;
    ETIMER_0.CH[2].CMPLD2.R = 1;//ڼʼֵ
    ETIMER_0.CH[2].CCCTRL.R = 0xE000;//0x8800;

    //Enable interrupt on compare 1 match
    ETIMER_0.CH[2].INTDMA.B.TCF1IE = 0x1;//.TCF2IE = 1;//	// Timer compare 2 flag interrupt enable
    ETIMER_0.CH[2].CTRL1.B.PRISRC = 0x18;       // Primary count source = IBBus clock devide by prescaler 1

    ETIMER_0.ENBL.R = 0x0004;
}//eTimer_Init

/*******************************************************************************
Function Name : ADC_Init
Engineer      : b21190
Date          : MAR-17-2015
Parameters    : NONE
Modifies      : NONE
Returns       : NONE
Notes         : Initialize ADC_0 module
Issues        : NONE
*******************************************************************************/
void ADC_Init(void)
{
    ADC_0.MCR.B.PWDN = 0;	// Enable ADC0
    /* 1 */
    ADC_0.MCR.B.CTUEN = 1;	// CTU mode enable
    /* 2 */
    ADC_0.NCMR0.R = 0xFFFF;	// Enable all ADC_0 channels
    ADC_0.MCR.B.MODE = 0;	// One-shot mode

}
/*******************************************************************************
* Global functions
*******************************************************************************/
void CTU_Init(void)
{
   //CTU setting
    CTU_0.TGSISR.B.I13_RE= 0x1;//OFLAGش
//	CTU_0.TGSISR.B.I13_FE= 0x1;//OFLAG½ش
    CTU_0.CR.B.TGSISR_RE= 0x1;		// Enable Reload the TGSISR double buffered register

    /************ڹ۲CTU start*************/
    CTU_0.TGSCR.B.ET_TM	= 0x1;		// Enable Toggle Mode for external Trigger	ڵ
    CTU_0.THCR1.B.T0_ETE = 0x1;		// Enable external trigger
    /************ڹ۲CTU end*************/

    CTU_0.TGSCR.B.PRES	= 0x1;		// CTUʱ2Ƶ=160/2=80MHz ADCʱһ
    CTU_0.TGSCR.B.TGS_M	= 0x0;		// Trigger Generator Subunit Mode = Triggered Mode

    // Trigger compare values
    CTU_0.TCR[0].R = 1000;		// Trigger 0 Compare Value    ʱ1000/80M=12.5us
    CTU_0.TGSCCR.R = 10000;		// ֵֹͣ
    CTU_0.TGSCRR.R = 0x0;		// TGS Counter Reload Value

    // Enable triggers from CTU TGS to other modules
    CTU_0.THCR1.B.T0_ADCE = 0x1;	// Trigger 0 ADC command output Enable
    CTU_0.THCR1.B.T0_E = 0x1;		// Trigger 0 Enable

    // Configure Commands List Control Register 1
    CTU_0.CLCR1.B.T0_INDEX = 0;		// Commands List Control Register 1. Valid values range from 0 through 23

    //Configure Commands List Registers
    CTU_0.CLR[0].A.B.CH = 0;		// ADC_0 channel 0
    CTU_0.CLR[1].A.B.CH = 1;		// ADC_0 channel 1
    CTU_0.CLR[2].A.B.CH = 2;		// ADC_0 channel 2
    CTU_0.CLR[3].A.B.CH = 3;		// ADC_0 channel 3
    CTU_0.CLR[4].A.B.CH = 4;		// ADC_0 channel 4 - This command is not executed as LC=1
    CTU_0.CLR[4].A.B.LC = 1;		// Stops the execution of command list at command 4 (excluding this command)

    CTU_0.FTH.R = 4-1;

    CTU_0.IFR.R = 0x1ff;//־λ

    //CTU_0.IR.B.DMA_DE = 1;//DMAɺԶGREλ=1
    CTU_0.FDCR.B.DE0 = 1;//CTU0_FIFO0ֵDMA
    // Update changes
    CTU_0.CR.B.GRE= 0x1;		// Reload double buffered registers

}//CTU_Init
//void DMA_Init()
//{
//	DMAMUX_0.CHCFG[0].B.ENBL = 0;
//	DMAMUX_0.CHCFG[0].B.TRIG = 0;
//	DMAMUX_0.CHCFG[0].B.SOURCE = 6;//CTU0Դ
//
//	//DMA_0.TCD[1]
//	DMA_0.ERQ.B.ERQ0 = 0;    //The DMA request signal for channel 0 is disabled.
//	//TCD config for channel[0]
//
//	// TCD[0] Word 0 config
//	DMA_0.TCD[0].SADDR.R = (uint32_t)(&CTU_0.FR[0].R);  	//Source Address
//	// TCD[0] Word 1 config SMOD(0) | SSIZE(32-bit) | DMOD(0) | DSIZE(32-bit)
//	DMA_0.TCD[0].ATTR.R = 0x0|0x200|0x0|0x2;	//Source transfer size 32-bit, no Address Modulo used
//
//	// TCD[0] Word 2 config NBYTES - Minor Byte Transfer Count
//	// Number of bytes to be transferred in each service request of the channel
//	// TCD[0] Word 2 config SMLOE(1) | DMLOE(1) | MLOFF(4) | NBYTES(100)
//	//DMA_0.TCD[1].NBYTES.MLOFFYES.R = 0x0|0x0|0x0|0x64;//ҾӦDMA_0.TCD[1].NBYTES.MLNO = 0x64;
//	DMA_0.TCD[0].NBYTES.MLOFFYES.R = 0x0|0x0|0x0|0x4;//ÿС4ֽ
//	// TCD[0] SOFF minor transfer interation offset = 0x4
//	DMA_0.TCD[0].SOFF.R = 0;//Դַƫ
//
//	// TCD[0] DOFF minor transfer interation offset = 0x4
//	DMA_0.TCD[0].DOFF.R = 0x4;//Ŀĵַƫ
//
//	// TCD[0] Word 3 config SLAST - TCD Last Source Address Adjustment
//	DMA_0.TCD[0].SLAST.R = 0;
//
//	DMA_0.TCD[0].DADDR.R = (uint32_t)destination_data;
//
//
//	// TCD[0] Word 5 config CITER - TCD Current Minor Loop Link, Major Loop Count
//	// ELINK | CITER
//	DMA_0.TCD[0].CITER.ELINKNO.R = 0x0 | 0x1;  //4
//
//	// TCD[0] Word 6 config DLAST_SGA - TCD Last Destination Address Adjustment/Scatter Gather Address
//	DMA_0.TCD[0].DLASTSGA.R = -4;	 // Ŀĵַƫ
//
//	// TCD[0] Word 7 config BITER - TCD Beginning Minor Loop Link, Major Loop Count
//	// ELINK | BITER
//	DMA_0.TCD[0].BITER.ELINKNO.R = 0x0 | 0x1;	 // Destination last address adjustment
//
//	DMA_0.ERQ.B.ERQ0 = 1;
//	DMA_0.SERQ.B.SAER=1;
//	DMAMUX_0.CHCFG[0].B.ENBL = 1;
//}
void DMA_Init()
{
	// Clear the ENBL and TRIG bits of the DMA channel
    DMAMUX_0.CHCFG[2].B.ENBL = 1;
    DMAMUX_0.CHCFG[2].B.TRIG = 0;
    DMAMUX_0.CHCFG[2].B.SOURCE = 6;

    // DMA_0 config
    DMA_0.ERQ.B.ERQ2 = 0;    //The DMA request signal for channel 0 is disabled.

    //TCD config for channel[1]

    // TCD[1] Word 0 config
    DMA_0.TCD[2].SADDR.R = (vuint32_t)(&CTU_0.FR[0].R);  	//Source Address

    // TCD[1] Word 1 config SMOD(0) | SSIZE(8-bit) | DMOD(0) | DSIZE(8-bit)
    DMA_0.TCD[2].ATTR.R = 0x0|0x200|0x0|0x2;	//Source transfer size 8-bit, no Address Modulo used

    // Number of bytes to be transferred in each service request of the channel
    DMA_0.TCD[2].NBYTES.MLNO.R = 16;

    // TCD[1] SOFF minor transfer iteration offset = 0x0
    DMA_0.TCD[2].SOFF.R = 0x0;

    // TCD[1] DOFF minor transfer iteration offset = 0x1
    DMA_0.TCD[2].DOFF.R = 0x4;

    // TCD[1] Word 3 config SLAST - TCD Last Source Address Adjustment
    DMA_0.TCD[2].SLAST.R = 0;

    // TCD[0] Word 4 config DADDR - TCD Destination Address
    DMA_0.TCD[2].DADDR.R = (vuint32_t)(&destination_data[0]);	 //Destination Address (LINFlexD_0.BDRL.DATA0)

    // TCD[1] Word 5 config CITER - TCD Current Minor Loop Link, Major Loop Count
    // ELINK | CITER
    DMA_0.TCD[2].CITER.ELINKNO.R = 0x0 | 0x1;  //Destination Address

    // TCD[1] Word 6 config DLAST_SGA - TCD Last Destination Address Adjustment/Scatter Gather Address
    DMA_0.TCD[2].DLASTSGA.R = -16;	 // Destination last address adjustment

    // TCD[1] Word 7 config BITER - TCD Beginning Minor Loop Link, Major Loop Count
    // ELINK | BITER
    DMA_0.TCD[2].BITER.ELINKNO.R = 0x0 | 0x1;	 // Destination last address adjustment



    //DMA_0.TCD[2].CSR.R = 0x0008;    //Stop after major loop finished
    DMA_0.TCD[2].CSR.B.DREQ = 0;
    DMA_0.TCD[2].CSR.B.INTHALF = 0;
    DMA_0.TCD[2].CSR.B.INTMAJOR = 0;
    DMA_0.TCD[2].CSR.B.MAJORELINK = 0;
    DMA_0.TCD[2].CSR.B.MAJORLINKCH = 0;
    DMA_0.TCD[2].CSR.B.ESG = 0;
    DMA_0.TCD[2].CSR.B.BWC = 0;
    DMA_0.TCD[2].CSR.B.START = 0;
    DMA_0.TCD[2].CSR.B.DONE = 0;
    DMA_0.TCD[2].CSR.B.ACTIVE = 0;

    DMA_0.ERQ.B.ERQ2 = 1; 	//The DMA request signal for channel 1 is enabled.

}


//extern void xcptn_xmpl(void);

int main (void)
{

	asm("wrteei 0");

	SysClk_Init();

	xcptn_xmpl();
    INTC_0.PSR[613].B.PRIN = 18;//100usж
	INTC_0.CPR0.B.PRI = 0;

	AIPS_0_Init();
	AIPS_1_Init();

	SUIL2_Init();
	ADC_Init();
	CTU_Init();
	DMA_Init();
	CAN_Init(0);
	eTimer_Init();
	asm("wrteei 1");
	while(1)
	{

	}
	return 0;
}//main

void ETimer_100us_ISR(void)//ĳ100us
{
	/************Զʱstart***********/
//	SIUL2.GPDO[84].R = ~SIUL2.GPDI[84].R;//ڲԶʱ
	/************Զʱend***********/
	//CTU_0.CR.B.GRE = 1;
//	count = CTU_0.FR[0].R;
//	count1 = CTU_0.FR[0].R;
//	CTU_0.EFR.R = CTU_0.EFR.R;
//	CTU_0.IFR.R = 0x1ff;
	count2++;
	if(count2 >= 100)//10msһ
	{
		CAN_Send(0,31,0x12345);
		count2 = 0;
	}
//	if(DMA_0.TCD[2].CSR.B.DONE)
//		DMA_0.CDNE.B.CADN = 1;
		//DMA_0.TCD[2].CSR.B.DONE = 0;
	ETIMER_0.CH[2].STS.R = 0x0002;             //clear interrupt flag
}
